%____copyright___="Copyright (C) 2022 A. Nolla, A.I. Muoz, E. Schiavi."
%____license____="GPL-3.0-only"

%Detalles sobre el empleo de los cdigos y ejercicios de aplicacin pueden
%encontrarse en las direcciones de los siguientes documentos elaborados por
%A. Nolla, A.I. Muoz, E. Schiavi:
%https://burjcdigital.urjc.es/handle/10115/20132
%https://burjcdigital.urjc.es/handle/10115/20134
%As como en el fichero Readme

% La mayor parte de los cdigos de la coleccin presentada en esta librera
%son adaptaciones de los publicados en el libro "Clculo cientfico con 
% Matlab y Octave" de A. Quarteroni y F. Saliery, 
% que se pueden obtener en https://mox.polimi.it/qs/.



function [sol,itera]=metodoaitken(g,x0,errorper,maxitera)

%este cdigo utiliza el mtodo de Aitken para obtener una aproximacin
%numrica al punto fjo de una funcin g, utilizando como semilla x0.
%errorper es el mximo error permitido en la aproximacin
%el error se vs calculando como la diferencia entre los valores obtenidos
%en dos iteraciones consecutivas
%maxitera es el mximo nmero de iteraciones que se permite realizar en el
%esqueme

x = x0;
difer = errorper + 1;
itera = 0;
while itera < maxiter & difer >= errorper
    gx = g(x);
    ggx = g(gx);
    xnew = (x*ggx-gx^2)/(ggx-2*gx+x);
    difer = abs(x-xnew);
    x = xnew;
    itera = itera  + 1;
end
if (itera==maxitera & difer>erroper)
    fprintf([' El mtodo no converge en el nmero',...
            ' mximo de iteraciones fijado ']);
end
sol = x;
return
